\begin{algorithm}
\caption{Infect and Die RLNC Middleware\label{algo1}}
\begin{algorithmic}[1]
  \State $k\gets ...$ \Comment{Fanout}
  \State $switch\gets ...$ \Comment{Control generation size}
  \State $split\gets ...$ \Comment{Control generation size}
  \item[]
  \State $g\gets \Call{rand}{0, split}$ \Comment{Encoding generation}
  \State $rcv\gets \varnothing$ \Comment{Received packets}
  \State $dlv\gets \varnothing$ \Comment{Delivered complete packets}
  \item[]

  \Function{NextGen}{h}
    \While{$h > g \lor \Call{Rank}{g, rcv} \geq switch$}
      \State $g \gets g + split$
    \EndWhile
  \EndFunction
  \item[]

  \Function{Disseminate}{h}
    \For{$k$ times}
      \State $p \gets \Call{Recode}{h, rcv} $
      \State $\Call{Send}{p}$
    \EndFor
  \EndFunction
  \item[]

  \Function{Broadcast}{e}
    \State $p\gets \langle g, \{ \Call{UniqueID}{ }: 1 \}, e \rangle$
    \State $rcv \gets rcv \cup \{ p \}$
    \State $dlv \gets dlv \cup \{ p \}$
    \State $\Call{Disseminate}{g}$
    \State $\Call{NextGen}{g}$
  \EndFunction
  \item[]

  \Function{Receive}{p}
    \State $ \langle h, \_, \_ \rangle \gets p$
    %\item[]

    \State $ oldRank \gets \Call{Rank}{h, rcv}$
    \State $rcv \gets \Call{Decode}{h, rcv \cup \{ p \}} $

    \If{$oldRank < \Call{Rank}{h, rcv}$}
      \ForAll{$q \in rcv \setminus dlv$}
        \State $\langle i, c, e \rangle \gets q$
        \If{$i = h \land c$ match $\{\_: 1\}$} 
	  \State $dlv \gets dlv \cup \{ q \}$
          \State $\Call{Deliver}{e}$
        \EndIf %\Comment We have decoded a new packet
      \EndFor
      \State $\Call{Disseminate}{h}$
      \State $\Call{NextGen}{h}$
    \EndIf %\Comment New information in the matrix
  \EndFunction
\end{algorithmic}
\end{algorithm}


